AWSTemplateFormatVersion: '2010-09-09'
Transform: AWS::Serverless-2016-10-31
Description: >
  card-tokenization

  Sample SAM Template for card-tokenization

# More info about Globals: https://github.com/awslabs/serverless-application-model/blob/master/docs/globals.rst
Globals:
  Function:
    Timeout: 20
    MemorySize: 512

    Tracing: Active
  Api:
    TracingEnabled: true
Resources:
  app:
    Type: AWS::Serverless::Function # More info about Function Resource: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#awsserverlessfunction
    FunctionName: app-local
    Properties:
      CodeUri: app/
      Handler: index.handler
      Runtime: nodejs14.x
      Architectures:
      - x86_64
      Tracing: Active
      Environment:
        Variables:
          POWERTOOLS_SERVICE_NAME: app
          POWERTOOLS_METRICS_NAMESPACE: card-tokenization
          LOG_LEVEL: INFO
      AssumeRolePolicyDocument:
        Version: "2012-10-17"
        Statement:
          - Effect: Allow
            Principal:
              Service: lambda.amazonaws.com
            Action: sts:AssumeRole
      Events:
        App:
          Type: Api # More info about API Event Source: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#api
          Properties:
            Path: /{proxy+}
            Method: any
      Policies:
        - Statement:
            - Sid: SecretsManagerFullAccess
              Effect: "Allow"
              Action:
                - "secretsmanager:*"
              Resource: "*"
        - Statement:
            - Sid: EventBridgePutEvents
              Effect: "Allow"
              Action:
                - "events:PutEvents"
              Resource: "*"
        - Statement:
            - Sid: LambdaInvokeFunction
              Effect: "Allow"
              Action:
                - "lambda:InvokeFunction"
              Resource: "*"
    Metadata: # Manage esbuild properties
      BuildMethod: esbuild
      BuildProperties:
        Minify: true
        Target: es2020
        # Sourcemap: true # Enabling source maps will create the required NODE_OPTIONS environment variables on your lambda function during sam build
        EntryPoints:
        - index.ts
